      SUBROUTINE PDSYEV5( UPLO, N, A, IA, JA, DESCA, IL, IU, ABSTOL,
     $                    M, W, WORK, LWORK, IWORK, LIWORK, INFO )
*
* Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            IA, INFO, JA, LIWORK, LWORK, M, N, IL, IU
      DOUBLE PRECISION   ABSTOL
*
* Array Arguments ..
      INTEGER            DESCA( * ), IWORK( * )
      DOUBLE PRECISION   A( * ), W( * ), WORK( * )
*
* Parameters ..
      INTEGER            CTXT_, MB_, NB_, RSRC_, CSRC_
      PARAMETER          ( CTXT_ = 2, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8 )
      DOUBLE PRECISION   ZERO, ONE, FIVE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, FIVE = 5.0D+0 )
      INTEGER            IERREBZ
      PARAMETER          ( IERREBZ = 8 )
*
* Local Scalars ..
      LOGICAL            LOWER, LQUERY, QUICKRETURN
      CHARACTER          ORDER
      INTEGER            CSRC_A, I, IAROW, ICOFFA, ICTXT, IINFO,
     $                   INDD, INDD2, INDE, INDE2, INDIBL, INDISP,
     $                   INDTAU, INDWORK, IROFFA, ISCALE,
     $                   ISIZESTEBZ, ISIZESTEIN, LALLWORK,
     $                   LIWMIN, LLWORK, LWMIN, LWOPT, MAXEIGS, MB_A,
     $                   MQ0, MYCOL, MYROW, NB, NB_A, NN, NNP,
     $                   NP0, NPCOL, NPROCS, NPROW, NSPLIT,
     $                   OFFSET, RSRC_A, SIZESYEVX
      DOUBLE PRECISION   ABSTLL, ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN,
     $                   SIGMA, SMLNUM
*
* Local Arrays ..
      INTEGER            IDUM1( 2 ), IDUM2( 2 )
*
* External Functions ..
      LOGICAL            LSAME
      INTEGER            ICEIL, INDXG2P, NUMROC
      DOUBLE PRECISION   PDLAMCH, PDLANSY
      EXTERNAL           LSAME, ICEIL, INDXG2P, NUMROC,
     $                   PDLAMCH, PDLANSY
*
* External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DGEBR2D, DGEBS2D,
     $                   DSCAL, PCHK1MAT, PDELGET, PDLARED1D, PDLASCL,
     $                   PDSTEBZ, PDSYNTRD, PXERBLA
*
* Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, ICHAR, MAX, MIN, MOD, SQRT
*
* Executable Statements ..
*
      QUICKRETURN = ( N.EQ.0 )
*
* Test the input arguments.
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      END IF
      IF( INFO.EQ.0 ) THEN
*
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, INFO )
         IF( INFO.EQ.0 ) THEN
*
* Get machine constants.
*
            SAFMIN = PDLAMCH( ICTXT, 'Safe minimum' )
            EPS = PDLAMCH( ICTXT, 'Precision' )
            SMLNUM = SAFMIN / EPS
            BIGNUM = ONE / SMLNUM
            RMIN = SQRT( SMLNUM )
            RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
            NPROCS = NPROW*NPCOL
            LOWER = LSAME( UPLO, 'L' )
*
* Set up pointers into the WORK array
*
            INDTAU = 1
            INDE = INDTAU + N
            INDD = INDE + N
            INDD2 = INDD + N
            INDE2 = INDD2 + N
            INDWORK = INDE2 + N
            LLWORK = LWORK - INDWORK + 1
*
* Set up pointers into the IWORK array
*
            ISIZESTEIN = 3*N + NPROCS + 1
            ISIZESTEBZ = MAX( 4*N, 14, NPROCS )
            INDIBL = ( MAX( ISIZESTEIN, ISIZESTEBZ ) ) + 1
            INDISP = INDIBL + N
*
* Compute the total amount of space needed
*
            LQUERY = .FALSE.
            IF( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
     $         LQUERY = .TRUE.
*
            NNP = MAX( N, NPROCS+1, 4 )
            LIWMIN = 6*NNP
*
            NPROCS = NPROW*NPCOL
            NB_A = DESCA( NB_ )
            MB_A = DESCA( MB_ )
            NB = NB_A
            NN = MAX( N, NB, 2 )
*
            RSRC_A = DESCA( RSRC_ )
            CSRC_A = DESCA( CSRC_ )
            IROFFA = MOD( IA-1, MB_A )
            ICOFFA = MOD( JA-1, NB_A )
            IAROW = INDXG2P( 1, NB_A, MYROW, RSRC_A, NPROW )
            NP0 = NUMROC( N+IROFFA, NB, 0, 0, NPROW )
            MQ0 = NUMROC( N+ICOFFA, NB, 0, 0, NPCOL )
               LWMIN = 5*N + MAX( 5*NN, NB*( NP0+1 ) )
               LWOPT = LWMIN
*
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
               WORK( 1 ) = ABSTOL
               WORK( 2 ) = ZERO
               WORK( 3 ) = ZERO
*
               CALL DGEBS2D( ICTXT, 'ALL', ' ', 3, 1, WORK, 3 )
            ELSE
               CALL DGEBR2D( ICTXT, 'ALL', ' ', 3, 1, WORK, 3, 0, 0 )
            END IF
            IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
               INFO = -1
            ELSE IF( IL.LT.1 .OR. IL .GT. MAX( 1, N ) ) THEN
               INFO = -7
            ELSE IF( IU .LT. MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -8
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -13
            ELSE IF( LIWORK.LT.LIWMIN .AND. LIWORK.NE.-1 ) THEN
               INFO = -15
            ELSE IF( ABS( WORK( 1 )-ABSTOL ).GT.FIVE*EPS*ABS( ABSTOL ) )
     $                THEN
               INFO = -9
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -4
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 600+NB_ )
            END IF
         END IF
         IF( LOWER ) THEN
            IDUM1( 1 ) = ICHAR( 'L' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'U' )
         END IF
         IDUM2( 1 ) = 1
         IF( LQUERY ) THEN
            IDUM1( 2 ) = -1
         ELSE
            IDUM1( 2 ) = 1
         END IF
         IDUM2( 2 ) = 2
*
            CALL PCHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, 2, IDUM1,
     $                     IDUM2, INFO )
         WORK( 1 ) = DBLE( LWOPT )
         IWORK( 1 ) = LIWMIN
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PDSYEV5', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
* Quick return if possible
*
      IF( QUICKRETURN ) THEN
         M = 0
         WORK( 1 ) = DBLE( LWOPT )
         IWORK( 1 ) = LIWMIN
         RETURN
      END IF
*
* Scale matrix to allowable range, if necessary.
*
      ABSTLL = ABSTOL
      ISCALE = 0
*
      ANRM = PDLANSY( 'M', UPLO, N, A, IA, JA, DESCA, WORK( INDWORK ) )
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
         ANRM = ANRM*SIGMA
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
         ANRM = ANRM*SIGMA
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PDLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
         IF( ABSTOL.GT.0 )
     $      ABSTLL = ABSTOL*SIGMA
      END IF
*
* Call PDSYNTRD to reduce symmetric matrix to tridiagonal form.
*
      LALLWORK = LLWORK
*
      CALL PDSYNTRD( UPLO, N, A, IA, JA, DESCA, WORK( INDD ),
     $               WORK( INDE ), WORK( INDTAU ), WORK( INDWORK ),
     $               LLWORK, IINFO )
*
*
* Copy the values of D, E to all processes
*
*     Here PDLARED1D is used to redistribute the tridiagonal matrix.
*     PDLARED1D, however, doesn't yet work with arbritary matrix
*     distributions so we have PDELGET as a backup.
*
      OFFSET = 0
      IF( IA.EQ.1 .AND. JA.EQ.1 .AND. RSRC_A.EQ.0 .AND. CSRC_A.EQ.0 )
     $     THEN
         CALL PDLARED1D( N, IA, JA, DESCA, WORK( INDD ), WORK( INDD2 ),
     $                   WORK( INDWORK ), LLWORK )
*
         CALL PDLARED1D( N, IA, JA, DESCA, WORK( INDE ), WORK( INDE2 ),
     $                   WORK( INDWORK ), LLWORK )
         IF( .NOT.LOWER )
     $      OFFSET = 1
      ELSE
         DO 10 I = 1, N
            CALL PDELGET( 'A', ' ', WORK( INDD2+I-1 ), A, I+IA-1,
     $                    I+JA-1, DESCA )
   10    CONTINUE
         IF( LSAME( UPLO, 'U' ) ) THEN
            DO 20 I = 1, N - 1
               CALL PDELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA-1,
     $                       I+JA, DESCA )
   20       CONTINUE
         ELSE
            DO 30 I = 1, N - 1
               CALL PDELGET( 'A', ' ', WORK( INDE2+I-1 ), A, I+IA,
     $                       I+JA-1, DESCA )
   30       CONTINUE
         END IF
      END IF
*
* Call PDSTEBZ.
*
      ORDER = 'E'
*
      CALL PDSTEBZ( ICTXT, 'I', ORDER, N, 0, 0, IL, IU, ABSTLL,
     $              WORK( INDD2 ), WORK( INDE2+OFFSET ), M, NSPLIT, W,
     $              IWORK( INDIBL ), IWORK( INDISP ), WORK( INDWORK ),
     $              LLWORK, IWORK( 1 ), ISIZESTEBZ, IINFO )
*
*     IF PDSTEBZ fails, the error propogates to INFO, but
*     we do not propogate the eigenvalue(s) which failed because:
*      This should never happen if the user specifies
*         ABSTOL = 2 * PDLAMCH( 'U' )
*
      IF( IINFO.NE.0 ) THEN
         INFO = INFO + IERREBZ
         DO 40 I = 1, M
            IWORK( INDIBL+I-1 ) = ABS( IWORK( INDIBL+I-1 ) )
   40    CONTINUE
      END IF
*
* If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( M, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = DBLE( LWOPT )
      IWORK( 1 ) = LIWMIN
*
      RETURN
*
*     End of PDSYEV5
*
      END
